unit ClientUpdate;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TClientUpdateForm = class(TForm)
    Image1: TImage;
    ButtonCancel: TButton;
    Memo1: TMemo;
    ButtonUpdate: TButton;
    CheckBoxForce: TCheckBox;
    RadioButtonImm: TRadioButton;
    RadioButtonPostpond: TRadioButton;
    procedure FormShow(Sender: TObject);
    procedure ButtonUpdateClick(Sender: TObject);
    procedure RadioButtonPostpondClick(Sender: TObject);
    procedure RadioButtonImmClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    constructor CreateForm(is_imm,is_force:boolean);
    destructor Destroy; override;
  end;


function ShowClientUpdateFormModal(var out_imm,out_force:boolean):boolean;


implementation

uses tools,lang;

{$R *.dfm}

const s_info_text:string =
': '#13#10+
',         (      ),            '+'(      ).'#13#10+
''#13#10+
'      ,    .'#13#10+
'   " "      10-15 .  ,   " ",          .     '+'     ,      .'#13#10+
'       : "-> ".'#13#10+
''#13#10+
'!     ShadowUser, DeepFreeze, Norton GoBack  .,      ,        . '#13#10+
'          .'#13#10+
'     Rollback     , ..        (  )   ,       .';



function ShowClientUpdateFormModal(var out_imm,out_force:boolean):boolean;
var f:TClientUpdateForm;
begin
 Result:=false;
 f:=TClientUpdateForm.CreateForm(false,false);
 if f.ShowModal=mrOk then
  begin
   out_imm:=f.RadioButtonImm.Checked;
   out_force:=f.CheckBoxForce.Checked;
   Result:=true;
  end;
 f.Free;
end;

constructor TClientUpdateForm.CreateForm(is_imm,is_force:boolean);
var i:TIcon;
begin
 inherited Create(nil);

 Memo1.Text:=s_info_text;

 i:=TIcon.Create();
 i.Handle:=Windows.CopyIcon(LoadImage(hinstance,pchar(242),IMAGE_ICON,32,32,LR_SHARED));
 Image1.Picture.Assign(i);
 i.Free;

 if is_imm then
  RadioButtonImm.Checked:=true
 else
  RadioButtonPostpond.Checked:=true;
 CheckBoxForce.Checked:=is_force;
end;

destructor TClientUpdateForm.Destroy;
begin
 Image1.Picture.Assign(nil);

 inherited;
end;

procedure TClientUpdateForm.FormShow(Sender: TObject);
begin
 ButtonUpdate.SetFocus;
end;

procedure TClientUpdateForm.RadioButtonPostpondClick(Sender: TObject);
begin
 if RadioButtonPostpond.Checked then
  begin
   CheckBoxForce.Enabled:=false;
  end;
end;

procedure TClientUpdateForm.RadioButtonImmClick(Sender: TObject);
begin
 if RadioButtonImm.Checked then
  begin
   CheckBoxForce.Enabled:=true;
  end;
end;

procedure TClientUpdateForm.ButtonUpdateClick(Sender: TObject);
begin
 ModalResult:=mrOk;
end;

end.
